---
- name: Playbook to stage/tftp .bin to switch bootflash
  hosts: Switch_Group
  gather_facts: False
  vars:
   tftp: 209.22.126.12
   new_version: 17.09.03
   new_image_ios: "cat9k_iosxe.{{ new_version }}.SPA.bin" 

  tasks:

  - name: Ensure TFTP blocksize
    cisco.ios.ios_config:
      lines: ip tftp blocksize 8192

  - name: check for old files and remove them if found
    cisco.ios.ios_command:
      commands:
        - command: 'install remove inactive'
          prompt: 
            - 'Do you want to remove the above files\? \[y/n\]'
          answer:
            - 'y'
    register: install_remove_output
    vars:
      ansible_command_timeout: 600

  - name: Display install_remove output and result
    ansible.builtin.debug:
      msg: "{{ 'No old files found. Nothing to clean.' if 'SUCCESS: No extra package or provisioning files found on media' in install_remove_output.stdout[0] else 'Old files removed successfully.' }}"
      
  - name: check if image already exist in bootflash
    cisco.ios.ios_command:
      commands: 'dir bootflash: | include {{ new_image_ios }}'
    register: check_image
  
  - name: fetch new image from tftp to bootflash
    vars:
      ansible_command_timeout: 2400
      number_of_retries: 2
    cisco.ios.ios_command:
      commands:
      - command: 'copy tftp://{{ tftp }}/{{ new_image_ios }} bootflash:{{ new_image_ios }}'   
        prompt: 'Destination filename \[{{ new_image_ios }}\]'
        answer: "\r"
      interval: 10
      retries: "{{ number_of_retries | int }}"
      wait_for: result[0] contains OK
    when: check_image.stdout[0].find( new_image_ios ) == -1

  - name: Set MD5 for 17.09.04
    ansible.builtin.set_fact:
      md5_hash: 6e7be69159f3a3f40afaf69f329a9465
    when: new_version == "17.09.04"

  - name: Set MD5 for 17.09.03
    ansible.builtin.set_fact:
      md5_hash: 68aa9aa3449616e245fdba42a8258dbb
    when: new_version == "17.09.03"    

  - name: Verify MD5 Hash of Image File
    vars:
      ansible_command_timeout: 1200
    ios_command:
      commands: 'verify /md5 bootflash:/{{ new_image_ios }} {{ md5_hash }}'
    register: md5_hash_verification_results
  
  - name: Set md5_hash_verification to pass/fail
    ansible.builtin.set_fact:
      md5_hash_verification: "pass"
    when: md5_hash_verification_results.stdout[0].find('Verified') != -1
      
  - name: Fail Task if MD5 Hash Check Fails
    fail:
      msg: "MD5 Hash Check Fails. Please check the uploaded image!"
    when: md5_hash_verification_results.stdout[0].find('Verified') == -1

